using System;
using System.Drawing;
using System.IO;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using pdftron;
using pdftron.PDF;
using pdftron.Common;

namespace PDFViewCS
{
	/// <summary>
	/// Summary description for ExportDialog.
	/// </summary>
	public class ExportDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TextBox fromBox;
		private System.Windows.Forms.TextBox toBox;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button browseButton;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ComboBox resolutionComboBox;
		private System.Windows.Forms.TextBox directoryTextBox;
		private System.Windows.Forms.ComboBox extensionComboBox;
		
		private PDFDoc _pdfdoc;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ExportDialog(PDFDoc doc)
		{
			this._pdfdoc=doc;
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			toBox.Text=(this._pdfdoc.GetPageCount()).ToString();
			extensionComboBox.SelectedIndex=0;
			resolutionComboBox.SelectedIndex=0;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ExportDialog));
			this.fromBox = new System.Windows.Forms.TextBox();
			this.toBox = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label4 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.resolutionComboBox = new System.Windows.Forms.ComboBox();
			this.okButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.extensionComboBox = new System.Windows.Forms.ComboBox();
			this.browseButton = new System.Windows.Forms.Button();
			this.directoryTextBox = new System.Windows.Forms.TextBox();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.SuspendLayout();
			// 
			// fromBox
			// 
			this.fromBox.Location = new System.Drawing.Point(136, 24);
			this.fromBox.Name = "fromBox";
			this.fromBox.Size = new System.Drawing.Size(40, 22);
			this.fromBox.TabIndex = 0;
			this.fromBox.Text = "1";
			// 
			// toBox
			// 
			this.toBox.Location = new System.Drawing.Point(288, 24);
			this.toBox.Name = "toBox";
			this.toBox.Size = new System.Drawing.Size(40, 22);
			this.toBox.TabIndex = 1;
			this.toBox.Text = "1";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(200, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 23);
			this.label1.TabIndex = 2;
			this.label1.Text = "To Page";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.toBox);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.fromBox);
			this.groupBox1.Location = new System.Drawing.Point(32, 152);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(384, 64);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Page Range";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(32, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(80, 23);
			this.label4.TabIndex = 3;
			this.label4.Text = "From Page";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.resolutionComboBox);
			this.groupBox2.Location = new System.Drawing.Point(32, 232);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(384, 64);
			this.groupBox2.TabIndex = 4;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Image Resolution";
			// 
			// resolutionComboBox
			// 
			this.resolutionComboBox.Items.AddRange(new object[] {
																	"50 DPI",
																	"72 DPI",
																	"92 DPI",
																	"200 DPI",
																	"300 DPI"});
			this.resolutionComboBox.Location = new System.Drawing.Point(96, 24);
			this.resolutionComboBox.Name = "resolutionComboBox";
			this.resolutionComboBox.Size = new System.Drawing.Size(184, 24);
			this.resolutionComboBox.TabIndex = 0;
			// 
			// okButton
			// 
			this.okButton.Location = new System.Drawing.Point(120, 320);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(80, 23);
			this.okButton.TabIndex = 5;
			this.okButton.Text = "OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// cancelButton
			// 
			this.cancelButton.Location = new System.Drawing.Point(248, 320);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.Size = new System.Drawing.Size(88, 23);
			this.cancelButton.TabIndex = 6;
			this.cancelButton.Text = "Cancel";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.label3);
			this.groupBox3.Controls.Add(this.label2);
			this.groupBox3.Controls.Add(this.extensionComboBox);
			this.groupBox3.Controls.Add(this.browseButton);
			this.groupBox3.Controls.Add(this.directoryTextBox);
			this.groupBox3.Location = new System.Drawing.Point(32, 16);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(384, 120);
			this.groupBox3.TabIndex = 7;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "File Information";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 72);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(72, 23);
			this.label3.TabIndex = 4;
			this.label3.Text = "Extension:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 24);
			this.label2.Name = "label2";
			this.label2.TabIndex = 3;
			this.label2.Text = "Root Directory:";
			// 
			// extensionComboBox
			// 
			this.extensionComboBox.Items.AddRange(new object[] {
																   "PNG (*.png)",
																   "TIF (*.tif)",
																   "JPG (*.jpg)",
																   "BMP (*.BMP)"});
			this.extensionComboBox.Location = new System.Drawing.Point(136, 72);
			this.extensionComboBox.Name = "extensionComboBox";
			this.extensionComboBox.Size = new System.Drawing.Size(136, 24);
			this.extensionComboBox.TabIndex = 2;
			// 
			// browseButton
			// 
			this.browseButton.Location = new System.Drawing.Point(272, 24);
			this.browseButton.Name = "browseButton";
			this.browseButton.TabIndex = 1;
			this.browseButton.Text = "Browse";
			this.browseButton.Click += new System.EventHandler(this.browseButton_Click);
			// 
			// directoryTextBox
			// 
			this.directoryTextBox.Location = new System.Drawing.Point(136, 24);
			this.directoryTextBox.Name = "directoryTextBox";
			this.directoryTextBox.Size = new System.Drawing.Size(136, 22);
			this.directoryTextBox.TabIndex = 0;
			this.directoryTextBox.Text = "";
			// 
			// ExportDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(442, 368);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.cancelButton);
			this.Controls.Add(this.okButton);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "ExportDialog";
			this.Text = "Export";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void okButton_Click(object sender, System.EventArgs e)
		{
			
			bool rangeFailed=false;
				
			PDFDraw draw = new PDFDraw();

			//Obtains the resolution in dpi from the users choice
			String dpi = ((String)resolutionComboBox.SelectedItem).TrimEnd((" DPI").ToCharArray());
			draw.SetDPI(System.Convert.ToInt32(dpi, 10));
			
			//finds the *.xyz extension in the user selected item
			//and stores it
			int starIndex=((String)extensionComboBox.SelectedItem).IndexOf("*");
			String extension=((String)extensionComboBox.SelectedItem).Substring(starIndex+1, 4);

			int to=1,from=1;
	
			try
			{
				to=System.Convert.ToInt32(toBox.Text);
				from=System.Convert.ToInt32(fromBox.Text);
			}
			catch(FormatException)
			{
				//The user did not input numbers
				rangeFailed=true;
			}

			//the upper bound on the range must be higher than
			//the lower bound and the pages must be in range
			if((to<from) || (this._pdfdoc.GetPageCount()<to) || from<1)
				rangeFailed=true;

			// if invalid input tell the user and return
			if(rangeFailed)
			{
				MessageBox.Show("Please Enter Valid Page Ranges");
				return;
			}

			String dirPath=directoryTextBox.Text;
			// Check if the given directory exists
			if(!Directory.Exists(dirPath))
			{
				//if it doesn't tell the user and return
				MessageBox.Show("Directory " + directoryTextBox.Text + " Does Not Exist");
				return;
			}

			// Rasterize the pages chosen by the user and
			// export them to the given location
			for(int i=from; i<=to; i++)
			{
				Page pg = _pdfdoc.GetPage(i);
				if (pg == null) return;
				draw.Export(pg, dirPath + "/Page" + i + extension);
			}
			this.Dispose();
		}

		private void browseButton_Click(object sender, System.EventArgs e)
		{
			// Opens a dialog box made for browsing directories
			FolderBrowserDialog dlg=new FolderBrowserDialog();
			DialogResult res=dlg.ShowDialog();
			if(res==DialogResult.OK)
				directoryTextBox.Text=dlg.SelectedPath;
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			this.Dispose();
		}
	}
}
