using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using pdftron;
using pdftron.PDF;
using pdftron.Filters;

namespace PDFViewCS
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MainMenu MainMenu;
		private System.Windows.Forms.MenuItem menuItemFile;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem menuItemView;
		private System.Windows.Forms.MenuItem menuItemToolbar;
		private System.Windows.Forms.MenuItem menuItemStatusbar;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItemHelp;
		private System.Windows.Forms.MenuItem MenuFileOpen;
		private System.Windows.Forms.MenuItem MenuFileClose;
		private System.Windows.Forms.MenuItem MenuFileSaveAs;
		private System.Windows.Forms.MenuItem MenuFileExport;
		private System.Windows.Forms.MenuItem MenuPrint;
		private System.Windows.Forms.MenuItem MenuExit;
		private System.Windows.Forms.MenuItem MenuViewZoomIn;
		private System.Windows.Forms.MenuItem MenuViewZoomOut;
		private System.Windows.Forms.MenuItem MenuViewFirtsPage;
		private System.Windows.Forms.MenuItem MenuViewPreviousPage;
		private System.Windows.Forms.MenuItem MenuViewNextPage;
		private System.Windows.Forms.MenuItem MenuViewLastPage;
		private System.Windows.Forms.MenuItem MenuViewAbout;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.ToolBar ToolBar;
		private System.Windows.Forms.ImageList ToolbarImageList;
		private System.Windows.Forms.ToolBarButton HandToolButton;
		private System.Windows.Forms.ToolBarButton PencilToolButton;
		private System.Windows.Forms.ToolBarButton FileOpenButton;
		private System.Windows.Forms.ToolBarButton SaveAsButton;
		private System.Windows.Forms.ToolBarButton PrintButton;
		private System.Windows.Forms.ToolBarButton ZoomInToolButton;
		private System.Windows.Forms.ToolBarButton ZoomOutToolButton;
		private System.Windows.Forms.ToolBarButton LinkCreateToolButton;
		private System.Windows.Forms.ToolBarButton TextSelectButton;
		private System.Windows.Forms.ToolBarButton RectTextSelectButton;
		private System.Windows.Forms.ToolBarButton FitPageButton;
		private System.Windows.Forms.ToolBarButton FitWidthButton;
		private System.Windows.Forms.ToolBarButton ZoomInButton;
		private System.Windows.Forms.ToolBarButton ZoomOutButton;
		private System.Windows.Forms.ToolBarButton FirstPageButton;
		private System.Windows.Forms.ToolBarButton PrevPageButton;
		private System.Windows.Forms.ToolBarButton NextPageButton;
		private System.Windows.Forms.ToolBarButton LastPageButton;
		private System.Windows.Forms.ToolBarButton PageSingleButton;
		private System.Windows.Forms.ToolBarButton PageSingleContButton;
		private System.Windows.Forms.ToolBarButton PageFacingContButton;
		private System.Windows.Forms.ToolBarButton PageFacingButton;
		private System.Windows.Forms.ToolBarButton RotateClockwise;
		private System.Windows.Forms.ToolBarButton RotateCounterClockwise;
		private System.Windows.Forms.ToolBarButton Separator1;
		private System.Windows.Forms.ToolBarButton Separator2;
		private System.Windows.Forms.ToolBarButton Separator3;
		private System.Windows.Forms.ToolBarButton Separator4;
		private System.Windows.Forms.ToolBarButton Separator5;
		private System.Windows.Forms.ToolBarButton Separator6;
		private System.Windows.Forms.ToolBarButton Separator7;
		private System.Windows.Forms.ToolBarButton Separator8;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem MenuSmoothImages;
		private System.Windows.Forms.MenuItem MenuFileSave;
		private System.Windows.Forms.MenuItem MenuFileCloseAll;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem MenuWindowTile;
		private System.Windows.Forms.MenuItem MenuWindowCascade;
		private System.Windows.Forms.MenuItem MenuWindowCloseAll;
		private System.Windows.Forms.MenuItem MenuWindowTileVertical;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem MenuAntiAlias;
		private System.Windows.Forms.MenuItem MenuBuiltInRasterizer;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.StatusBarPanel statusBarPanel;

		private bool smooth_images = true;
		private bool anti_alias = true;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem CopyText;
		private System.Windows.Forms.MenuItem CopyTextAsHTML;
		private System.Windows.Forms.MenuItem SelectAllText;
		private System.Windows.Forms.MenuItem DeselectAllText;
		private System.Windows.Forms.MenuItem FindText;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuPanTool;
		private System.Windows.Forms.MenuItem menuStructTextTool;
		private System.Windows.Forms.MenuItem menuRectTextTool;
		private System.Windows.Forms.MenuItem menuRectZoomInTool;
		private System.Windows.Forms.MenuItem menuRectZoomOutTool;
		private System.Windows.Forms.MenuItem menuLineAnnotTool;
		private System.Windows.Forms.MenuItem menuRectAnnotTool;
		private System.Windows.Forms.MenuItem menuEllipseAnnotTool;
		private System.Windows.Forms.MenuItem menuFreeHandAnnotTool;
		private System.Windows.Forms.MenuItem menuArrowAnnotTool;
		private System.Windows.Forms.MenuItem menuAnnotEditTool;
		private System.Windows.Forms.MenuItem menuCustomDrawTool;
		private System.Windows.Forms.MenuItem menuCustomLinkTool;
		private System.Windows.Forms.MenuItem menuCustomTextSelectTool;
		private MenuItem menuItemDocument;
		private MenuItem DeletePages;
		private MenuItem menuItem10;
		private MenuItem menuItem11;
		private MenuItem menuItem13;
		private MenuItem menuItem14;
		private MenuItem menuItem16;
		private MenuItem DocProperties;
		private MenuItem menuItem17;
		private bool builtin_rasterizer = true;


		public MainForm()
		{
			// Required for Windows Form Designer support
			InitializeComponent();

			// Add any constructor code after InitializeComponent call
			// UpdateButtonStates();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.MainMenu = new System.Windows.Forms.MainMenu();
            this.menuItemFile = new System.Windows.Forms.MenuItem();
            this.MenuFileOpen = new System.Windows.Forms.MenuItem();
            this.MenuFileClose = new System.Windows.Forms.MenuItem();
            this.MenuFileCloseAll = new System.Windows.Forms.MenuItem();
            this.MenuFileSave = new System.Windows.Forms.MenuItem();
            this.MenuFileSaveAs = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.MenuFileExport = new System.Windows.Forms.MenuItem();
            this.menuItem12 = new System.Windows.Forms.MenuItem();
            this.MenuPrint = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.MenuExit = new System.Windows.Forms.MenuItem();
            this.menuItem7 = new System.Windows.Forms.MenuItem();
            this.CopyText = new System.Windows.Forms.MenuItem();
            this.CopyTextAsHTML = new System.Windows.Forms.MenuItem();
            this.SelectAllText = new System.Windows.Forms.MenuItem();
            this.DeselectAllText = new System.Windows.Forms.MenuItem();
            this.menuItem9 = new System.Windows.Forms.MenuItem();
            this.FindText = new System.Windows.Forms.MenuItem();
            this.menuItemView = new System.Windows.Forms.MenuItem();
            this.menuItemToolbar = new System.Windows.Forms.MenuItem();
            this.menuItemStatusbar = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.MenuViewZoomIn = new System.Windows.Forms.MenuItem();
            this.MenuViewZoomOut = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.MenuViewFirtsPage = new System.Windows.Forms.MenuItem();
            this.MenuViewPreviousPage = new System.Windows.Forms.MenuItem();
            this.MenuViewNextPage = new System.Windows.Forms.MenuItem();
            this.MenuViewLastPage = new System.Windows.Forms.MenuItem();
            this.menuItemDocument = new System.Windows.Forms.MenuItem();
            this.menuItem16 = new System.Windows.Forms.MenuItem();
            this.DocProperties = new System.Windows.Forms.MenuItem();
            this.menuItem17 = new System.Windows.Forms.MenuItem();
            this.DeletePages = new System.Windows.Forms.MenuItem();
            this.menuItem11 = new System.Windows.Forms.MenuItem();
            this.menuItem13 = new System.Windows.Forms.MenuItem();
            this.menuItem14 = new System.Windows.Forms.MenuItem();
            this.menuItem10 = new System.Windows.Forms.MenuItem();
            this.menuItem8 = new System.Windows.Forms.MenuItem();
            this.menuPanTool = new System.Windows.Forms.MenuItem();
            this.menuStructTextTool = new System.Windows.Forms.MenuItem();
            this.menuRectTextTool = new System.Windows.Forms.MenuItem();
            this.menuRectZoomInTool = new System.Windows.Forms.MenuItem();
            this.menuRectZoomOutTool = new System.Windows.Forms.MenuItem();
            this.menuLineAnnotTool = new System.Windows.Forms.MenuItem();
            this.menuRectAnnotTool = new System.Windows.Forms.MenuItem();
            this.menuEllipseAnnotTool = new System.Windows.Forms.MenuItem();
            this.menuFreeHandAnnotTool = new System.Windows.Forms.MenuItem();
            this.menuArrowAnnotTool = new System.Windows.Forms.MenuItem();
            this.menuAnnotEditTool = new System.Windows.Forms.MenuItem();
            this.menuCustomDrawTool = new System.Windows.Forms.MenuItem();
            this.menuCustomLinkTool = new System.Windows.Forms.MenuItem();
            this.menuCustomTextSelectTool = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.MenuSmoothImages = new System.Windows.Forms.MenuItem();
            this.MenuAntiAlias = new System.Windows.Forms.MenuItem();
            this.MenuBuiltInRasterizer = new System.Windows.Forms.MenuItem();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.MenuWindowTile = new System.Windows.Forms.MenuItem();
            this.MenuWindowTileVertical = new System.Windows.Forms.MenuItem();
            this.MenuWindowCascade = new System.Windows.Forms.MenuItem();
            this.MenuWindowCloseAll = new System.Windows.Forms.MenuItem();
            this.menuItemHelp = new System.Windows.Forms.MenuItem();
            this.MenuViewAbout = new System.Windows.Forms.MenuItem();
            this.ToolBar = new System.Windows.Forms.ToolBar();
            this.FileOpenButton = new System.Windows.Forms.ToolBarButton();
            this.SaveAsButton = new System.Windows.Forms.ToolBarButton();
            this.PrintButton = new System.Windows.Forms.ToolBarButton();
            this.Separator1 = new System.Windows.Forms.ToolBarButton();
            this.HandToolButton = new System.Windows.Forms.ToolBarButton();
            this.RectTextSelectButton = new System.Windows.Forms.ToolBarButton();
            this.TextSelectButton = new System.Windows.Forms.ToolBarButton();
            this.Separator8 = new System.Windows.Forms.ToolBarButton();
            this.PencilToolButton = new System.Windows.Forms.ToolBarButton();
            this.LinkCreateToolButton = new System.Windows.Forms.ToolBarButton();
            this.Separator2 = new System.Windows.Forms.ToolBarButton();
            this.FitPageButton = new System.Windows.Forms.ToolBarButton();
            this.FitWidthButton = new System.Windows.Forms.ToolBarButton();
            this.Separator3 = new System.Windows.Forms.ToolBarButton();
            this.ZoomInToolButton = new System.Windows.Forms.ToolBarButton();
            this.ZoomOutToolButton = new System.Windows.Forms.ToolBarButton();
            this.Separator7 = new System.Windows.Forms.ToolBarButton();
            this.ZoomInButton = new System.Windows.Forms.ToolBarButton();
            this.ZoomOutButton = new System.Windows.Forms.ToolBarButton();
            this.Separator4 = new System.Windows.Forms.ToolBarButton();
            this.FirstPageButton = new System.Windows.Forms.ToolBarButton();
            this.PrevPageButton = new System.Windows.Forms.ToolBarButton();
            this.NextPageButton = new System.Windows.Forms.ToolBarButton();
            this.LastPageButton = new System.Windows.Forms.ToolBarButton();
            this.Separator5 = new System.Windows.Forms.ToolBarButton();
            this.PageSingleButton = new System.Windows.Forms.ToolBarButton();
            this.PageSingleContButton = new System.Windows.Forms.ToolBarButton();
            this.PageFacingContButton = new System.Windows.Forms.ToolBarButton();
            this.PageFacingButton = new System.Windows.Forms.ToolBarButton();
            this.Separator6 = new System.Windows.Forms.ToolBarButton();
            this.RotateClockwise = new System.Windows.Forms.ToolBarButton();
            this.RotateCounterClockwise = new System.Windows.Forms.ToolBarButton();
            this.ToolbarImageList = new System.Windows.Forms.ImageList(this.components);
            this.statusBar = new System.Windows.Forms.StatusBar();
            this.statusBarPanel = new System.Windows.Forms.StatusBarPanel();
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel)).BeginInit();
            this.SuspendLayout();
            // 
            // MainMenu
            // 
            this.MainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemFile,
            this.menuItem7,
            this.menuItemView,
            this.menuItemDocument,
            this.menuItem8,
            this.menuItem3,
            this.menuItem5,
            this.menuItemHelp});
            // 
            // menuItemFile
            // 
            this.menuItemFile.Index = 0;
            this.menuItemFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.MenuFileOpen,
            this.MenuFileClose,
            this.MenuFileCloseAll,
            this.MenuFileSave,
            this.MenuFileSaveAs,
            this.menuItem2,
            this.MenuFileExport,
            this.menuItem12,
            this.MenuPrint,
            this.menuItem6,
            this.MenuExit});
            this.menuItemFile.Text = "File";
            // 
            // MenuFileOpen
            // 
            this.MenuFileOpen.Index = 0;
            this.MenuFileOpen.Text = "Open...";
            this.MenuFileOpen.Click += new System.EventHandler(this.OnFileOpen);
            // 
            // MenuFileClose
            // 
            this.MenuFileClose.Index = 1;
            this.MenuFileClose.Text = "Close";
            this.MenuFileClose.Click += new System.EventHandler(this.OnFileClose);
            // 
            // MenuFileCloseAll
            // 
            this.MenuFileCloseAll.Index = 2;
            this.MenuFileCloseAll.Text = "Close All";
            this.MenuFileCloseAll.Click += new System.EventHandler(this.OnFileCloseAll);
            // 
            // MenuFileSave
            // 
            this.MenuFileSave.Index = 3;
            this.MenuFileSave.Text = "Save";
            this.MenuFileSave.Click += new System.EventHandler(this.MenuFileSave_Click);
            // 
            // MenuFileSaveAs
            // 
            this.MenuFileSaveAs.Index = 4;
            this.MenuFileSaveAs.Text = "Save As...";
            this.MenuFileSaveAs.Click += new System.EventHandler(this.MenuFileSaveAs_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 5;
            this.menuItem2.Text = "-";
            // 
            // MenuFileExport
            // 
            this.MenuFileExport.Index = 6;
            this.MenuFileExport.Text = "Export...";
            this.MenuFileExport.Click += new System.EventHandler(this.MenuFileExport_Click);
            // 
            // menuItem12
            // 
            this.menuItem12.Index = 7;
            this.menuItem12.Text = "-";
            // 
            // MenuPrint
            // 
            this.MenuPrint.Index = 8;
            this.MenuPrint.Text = "Print...";
            this.MenuPrint.Click += new System.EventHandler(this.MenuPrint_Click);
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 9;
            this.menuItem6.Text = "-";
            // 
            // MenuExit
            // 
            this.MenuExit.Index = 10;
            this.MenuExit.Text = "Exit";
            this.MenuExit.Click += new System.EventHandler(this.OnAppExit);
            // 
            // menuItem7
            // 
            this.menuItem7.Index = 1;
            this.menuItem7.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.CopyText,
            this.CopyTextAsHTML,
            this.SelectAllText,
            this.DeselectAllText,
            this.menuItem9,
            this.FindText});
            this.menuItem7.Text = "Edit";
            // 
            // CopyText
            // 
            this.CopyText.Index = 0;
            this.CopyText.Text = "Copy";
            this.CopyText.Click += new System.EventHandler(this.CopyText_Click);
            // 
            // CopyTextAsHTML
            // 
            this.CopyTextAsHTML.Index = 1;
            this.CopyTextAsHTML.Text = "Copy as HTML";
            this.CopyTextAsHTML.Click += new System.EventHandler(this.CopyTextAsHTML_Click);
            // 
            // SelectAllText
            // 
            this.SelectAllText.Index = 2;
            this.SelectAllText.Text = "Select All";
            this.SelectAllText.Click += new System.EventHandler(this.SelectAllText_Click);
            // 
            // DeselectAllText
            // 
            this.DeselectAllText.Index = 3;
            this.DeselectAllText.Text = "Deselect All";
            this.DeselectAllText.Click += new System.EventHandler(this.DeselectAllText_Click);
            // 
            // menuItem9
            // 
            this.menuItem9.Index = 4;
            this.menuItem9.Text = "-";
            // 
            // FindText
            // 
            this.FindText.Index = 5;
            this.FindText.Text = "Find";
            this.FindText.Click += new System.EventHandler(this.FindText_Click);
            // 
            // menuItemView
            // 
            this.menuItemView.Index = 2;
            this.menuItemView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemToolbar,
            this.menuItemStatusbar,
            this.menuItem1,
            this.MenuViewZoomIn,
            this.MenuViewZoomOut,
            this.menuItem4,
            this.MenuViewFirtsPage,
            this.MenuViewPreviousPage,
            this.MenuViewNextPage,
            this.MenuViewLastPage});
            this.menuItemView.Text = "View";
            // 
            // menuItemToolbar
            // 
            this.menuItemToolbar.Checked = true;
            this.menuItemToolbar.Index = 0;
            this.menuItemToolbar.Text = "Toolbar";
            this.menuItemToolbar.Click += new System.EventHandler(this.menuItemToolbar_Click);
            // 
            // menuItemStatusbar
            // 
            this.menuItemStatusbar.Checked = true;
            this.menuItemStatusbar.Index = 1;
            this.menuItemStatusbar.Text = "Status Bar";
            this.menuItemStatusbar.Click += new System.EventHandler(this.menuItemStatusbar_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 2;
            this.menuItem1.Text = "-";
            // 
            // MenuViewZoomIn
            // 
            this.MenuViewZoomIn.Index = 3;
            this.MenuViewZoomIn.Text = "Zoom In";
            this.MenuViewZoomIn.Click += new System.EventHandler(this.OnZoomIn);
            // 
            // MenuViewZoomOut
            // 
            this.MenuViewZoomOut.Index = 4;
            this.MenuViewZoomOut.Text = "Zoom Out";
            this.MenuViewZoomOut.Click += new System.EventHandler(this.OnZoomOut);
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 5;
            this.menuItem4.Text = "-";
            // 
            // MenuViewFirtsPage
            // 
            this.MenuViewFirtsPage.Index = 6;
            this.MenuViewFirtsPage.Text = "First Page";
            this.MenuViewFirtsPage.Click += new System.EventHandler(this.OnFirstPage);
            // 
            // MenuViewPreviousPage
            // 
            this.MenuViewPreviousPage.Index = 7;
            this.MenuViewPreviousPage.Text = "Previous Page";
            this.MenuViewPreviousPage.Click += new System.EventHandler(this.OnPrevPage);
            // 
            // MenuViewNextPage
            // 
            this.MenuViewNextPage.Index = 8;
            this.MenuViewNextPage.Text = "Next Page";
            this.MenuViewNextPage.Click += new System.EventHandler(this.OnNextPage);
            // 
            // MenuViewLastPage
            // 
            this.MenuViewLastPage.Index = 9;
            this.MenuViewLastPage.Text = "Last Page";
            this.MenuViewLastPage.Click += new System.EventHandler(this.OnLastPage);
            // 
            // menuItemDocument
            // 
            this.menuItemDocument.Index = 3;
            this.menuItemDocument.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem16,
            this.DocProperties,
            this.menuItem17,
            this.DeletePages,
            this.menuItem11,
            this.menuItem10});
            this.menuItemDocument.Text = "Document";
            // 
            // menuItem16
            // 
            this.menuItem16.Index = 0;
            this.menuItem16.Text = "-";
            // 
            // DocProperties
            // 
            this.DocProperties.Index = 1;
            this.DocProperties.Text = "Document Properties";
            this.DocProperties.Click += new System.EventHandler(this.DocProperties_Click);
            // 
            // menuItem17
            // 
            this.menuItem17.Index = 2;
            this.menuItem17.Text = "-";
            // 
            // DeletePages
            // 
            this.DeletePages.Index = 3;
            this.DeletePages.Text = "Delete Pages";
            this.DeletePages.Click += new System.EventHandler(this.DeletePages_Click);
            // 
            // menuItem11
            // 
            this.menuItem11.Index = 4;
            this.menuItem11.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem13,
            this.menuItem14});
            this.menuItem11.Text = "Insert...";
            // 
            // menuItem13
            // 
            this.menuItem13.Index = 0;
            this.menuItem13.Text = "Blank Pages";
            this.menuItem13.Click += new System.EventHandler(this.InsertBlankPages_Click);
            // 
            // menuItem14
            // 
            this.menuItem14.Index = 1;
            this.menuItem14.Text = "Pages From File...";
            this.menuItem14.Click += new System.EventHandler(this.InsertPages_Click);
            // 
            // menuItem10
            // 
            this.menuItem10.Index = 5;
            this.menuItem10.Text = "Replace Pages";
            this.menuItem10.Click += new System.EventHandler(this.ReplacePages_Click);
            // 
            // menuItem8
            // 
            this.menuItem8.Index = 4;
            this.menuItem8.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuPanTool,
            this.menuStructTextTool,
            this.menuRectTextTool,
            this.menuRectZoomInTool,
            this.menuRectZoomOutTool,
            this.menuLineAnnotTool,
            this.menuRectAnnotTool,
            this.menuEllipseAnnotTool,
            this.menuFreeHandAnnotTool,
            this.menuArrowAnnotTool,
            this.menuAnnotEditTool,
            this.menuCustomDrawTool,
            this.menuCustomLinkTool,
            this.menuCustomTextSelectTool});
            this.menuItem8.Text = "Tools";
            // 
            // menuPanTool
            // 
            this.menuPanTool.Index = 0;
            this.menuPanTool.Text = "Pan";
            this.menuPanTool.Click += new System.EventHandler(this.menuPanTool_Click);
            // 
            // menuStructTextTool
            // 
            this.menuStructTextTool.Index = 1;
            this.menuStructTextTool.Text = "Structural Text Selection";
            this.menuStructTextTool.Click += new System.EventHandler(this.menuStructTextTool_Click);
            // 
            // menuRectTextTool
            // 
            this.menuRectTextTool.Index = 2;
            this.menuRectTextTool.Text = "Rectangular Text Selection";
            this.menuRectTextTool.Click += new System.EventHandler(this.menuRectTextTool_Click);
            // 
            // menuRectZoomInTool
            // 
            this.menuRectZoomInTool.Index = 3;
            this.menuRectZoomInTool.Text = "Rectangular Zoom-In";
            this.menuRectZoomInTool.Click += new System.EventHandler(this.menuRectZoomInTool_Click);
            // 
            // menuRectZoomOutTool
            // 
            this.menuRectZoomOutTool.Index = 4;
            this.menuRectZoomOutTool.Text = "Rectangular Zoom-Out";
            this.menuRectZoomOutTool.Click += new System.EventHandler(this.menuRectZoomOutTool_Click);
            // 
            // menuLineAnnotTool
            // 
            this.menuLineAnnotTool.Index = 5;
            this.menuLineAnnotTool.Text = "Line Annotation";
            this.menuLineAnnotTool.Click += new System.EventHandler(this.menuLineAnnotTool_Click);
            // 
            // menuRectAnnotTool
            // 
            this.menuRectAnnotTool.Index = 6;
            this.menuRectAnnotTool.Text = "Rectangle Annotation";
            this.menuRectAnnotTool.Click += new System.EventHandler(this.menuRectAnnotTool_Click);
            // 
            // menuEllipseAnnotTool
            // 
            this.menuEllipseAnnotTool.Index = 7;
            this.menuEllipseAnnotTool.Text = "Ellipse Annotation";
            this.menuEllipseAnnotTool.Click += new System.EventHandler(this.menuEllipseAnnotTool_Click);
            // 
            // menuFreeHandAnnotTool
            // 
            this.menuFreeHandAnnotTool.Index = 8;
            this.menuFreeHandAnnotTool.Text = "Freehand Annotation";
            this.menuFreeHandAnnotTool.Click += new System.EventHandler(this.menuFreeHandAnnotTool_Click);
            // 
            // menuArrowAnnotTool
            // 
            this.menuArrowAnnotTool.Index = 9;
            this.menuArrowAnnotTool.Text = "Arrow Annotation";
            this.menuArrowAnnotTool.Click += new System.EventHandler(this.menuArrowAnnotTool_Click);
            // 
            // menuAnnotEditTool
            // 
            this.menuAnnotEditTool.Index = 10;
            this.menuAnnotEditTool.Text = "Annotation Edit";
            this.menuAnnotEditTool.Click += new System.EventHandler(this.menuAnnotEditTool_Click);
            // 
            // menuCustomDrawTool
            // 
            this.menuCustomDrawTool.Index = 11;
            this.menuCustomDrawTool.Text = "Custom PDF Draw Tool";
            this.menuCustomDrawTool.Click += new System.EventHandler(this.menuCustomDrawTool_Click);
            // 
            // menuCustomLinkTool
            // 
            this.menuCustomLinkTool.Index = 12;
            this.menuCustomLinkTool.Text = "Custom Link Create Tool";
            this.menuCustomLinkTool.Click += new System.EventHandler(this.menuCustomLinkTool_Click);
            // 
            // menuCustomTextSelectTool
            // 
            this.menuCustomTextSelectTool.Index = 13;
            this.menuCustomTextSelectTool.Text = "Custom Text Select Tool";
            this.menuCustomTextSelectTool.Click += new System.EventHandler(this.menuCustomTextSelectTool_Click);
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 5;
            this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.MenuSmoothImages,
            this.MenuAntiAlias,
            this.MenuBuiltInRasterizer});
            this.menuItem3.Text = "Options";
            // 
            // MenuSmoothImages
            // 
            this.MenuSmoothImages.Checked = true;
            this.MenuSmoothImages.Index = 0;
            this.MenuSmoothImages.Text = "Smooth Images";
            this.MenuSmoothImages.Click += new System.EventHandler(this.OnSmoothImages);
            // 
            // MenuAntiAlias
            // 
            this.MenuAntiAlias.Checked = true;
            this.MenuAntiAlias.Index = 1;
            this.MenuAntiAlias.Text = "Anti-Aliased Rendering";
            this.MenuAntiAlias.Click += new System.EventHandler(this.OnAntiAlias);
            // 
            // MenuBuiltInRasterizer
            // 
            this.MenuBuiltInRasterizer.Checked = true;
            this.MenuBuiltInRasterizer.Index = 2;
            this.MenuBuiltInRasterizer.Text = "Built-In Rasterizer";
            this.MenuBuiltInRasterizer.Click += new System.EventHandler(this.OnRasterizerToggle);
            // 
            // menuItem5
            // 
            this.menuItem5.Index = 6;
            this.menuItem5.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.MenuWindowTile,
            this.MenuWindowTileVertical,
            this.MenuWindowCascade,
            this.MenuWindowCloseAll});
            this.menuItem5.Text = "Window";
            // 
            // MenuWindowTile
            // 
            this.MenuWindowTile.Index = 0;
            this.MenuWindowTile.Text = "Tile Horizontal";
            this.MenuWindowTile.Click += new System.EventHandler(this.OnWindowTile);
            // 
            // MenuWindowTileVertical
            // 
            this.MenuWindowTileVertical.Index = 1;
            this.MenuWindowTileVertical.Text = "Tile Vertical";
            this.MenuWindowTileVertical.Click += new System.EventHandler(this.OnWindowTileVertical);
            // 
            // MenuWindowCascade
            // 
            this.MenuWindowCascade.Index = 2;
            this.MenuWindowCascade.Text = "Cascade";
            this.MenuWindowCascade.Click += new System.EventHandler(this.OnWindowCascade);
            // 
            // MenuWindowCloseAll
            // 
            this.MenuWindowCloseAll.Index = 3;
            this.MenuWindowCloseAll.Text = "Close All";
            this.MenuWindowCloseAll.Click += new System.EventHandler(this.OnFileCloseAll);
            // 
            // menuItemHelp
            // 
            this.menuItemHelp.Index = 7;
            this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.MenuViewAbout});
            this.menuItemHelp.Text = "Help";
            // 
            // MenuViewAbout
            // 
            this.MenuViewAbout.Index = 0;
            this.MenuViewAbout.Text = "About PDFView";
            this.MenuViewAbout.Click += new System.EventHandler(this.OnAboutPDFView);
            // 
            // ToolBar
            // 
            this.ToolBar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
            this.ToolBar.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ToolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.FileOpenButton,
            this.SaveAsButton,
            this.PrintButton,
            this.Separator1,
            this.HandToolButton,
            this.RectTextSelectButton,
            this.TextSelectButton,
            this.Separator8,
            this.PencilToolButton,
            this.LinkCreateToolButton,
            this.Separator2,
            this.FitPageButton,
            this.FitWidthButton,
            this.Separator3,
            this.ZoomInToolButton,
            this.ZoomOutToolButton,
            this.Separator7,
            this.ZoomInButton,
            this.ZoomOutButton,
            this.Separator4,
            this.FirstPageButton,
            this.PrevPageButton,
            this.NextPageButton,
            this.LastPageButton,
            this.Separator5,
            this.PageSingleButton,
            this.PageSingleContButton,
            this.PageFacingContButton,
            this.PageFacingButton,
            this.Separator6,
            this.RotateClockwise,
            this.RotateCounterClockwise});
            this.ToolBar.ButtonSize = new System.Drawing.Size(30, 25);
            this.ToolBar.Cursor = System.Windows.Forms.Cursors.Default;
            this.ToolBar.DropDownArrows = true;
            this.ToolBar.ImageList = this.ToolbarImageList;
            this.ToolBar.Location = new System.Drawing.Point(0, 0);
            this.ToolBar.Name = "ToolBar";
            this.ToolBar.ShowToolTips = true;
            this.ToolBar.Size = new System.Drawing.Size(699, 85);
            this.ToolBar.TabIndex = 0;
            this.ToolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.ToolBar_ButtonClick);
            // 
            // FileOpenButton
            // 
            this.FileOpenButton.ImageIndex = ((int)(configurationAppSettings.GetValue("FileOpenButton.ImageIndex", typeof(int))));
            this.FileOpenButton.ToolTipText = "Open";
            // 
            // SaveAsButton
            // 
            this.SaveAsButton.ImageIndex = ((int)(configurationAppSettings.GetValue("SaveAsButton.ImageIndex", typeof(int))));
            this.SaveAsButton.ToolTipText = "Save";
            // 
            // PrintButton
            // 
            this.PrintButton.ImageIndex = ((int)(configurationAppSettings.GetValue("PrintButton.ImageIndex", typeof(int))));
            this.PrintButton.ToolTipText = "Print";
            // 
            // Separator1
            // 
            this.Separator1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // HandToolButton
            // 
            this.HandToolButton.ImageIndex = ((int)(configurationAppSettings.GetValue("HandTool.ImageIndex", typeof(int))));
            this.HandToolButton.Pushed = true;
            this.HandToolButton.ToolTipText = "Hand Tool";
            // 
            // RectTextSelectButton
            // 
            this.RectTextSelectButton.ImageIndex = 23;
            this.RectTextSelectButton.ToolTipText = "Rectangular Text Selection Tool";
            // 
            // TextSelectButton
            // 
            this.TextSelectButton.ImageIndex = 22;
            this.TextSelectButton.ToolTipText = "Structure Text Selection Tool";
            // 
            // Separator8
            // 
            this.Separator8.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // PencilToolButton
            // 
            this.PencilToolButton.ImageIndex = 18;
            this.PencilToolButton.ToolTipText = "Custom Pencil Tool";
            // 
            // LinkCreateToolButton
            // 
            this.LinkCreateToolButton.ImageIndex = 21;
            this.LinkCreateToolButton.ToolTipText = "Custom Link Tool";
            // 
            // Separator2
            // 
            this.Separator2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // FitPageButton
            // 
            this.FitPageButton.ImageIndex = ((int)(configurationAppSettings.GetValue("FitPageButton.ImageIndex", typeof(int))));
            this.FitPageButton.ToolTipText = "Fit Page";
            // 
            // FitWidthButton
            // 
            this.FitWidthButton.ImageIndex = ((int)(configurationAppSettings.GetValue("FitWidthButton.ImageIndex", typeof(int))));
            this.FitWidthButton.ToolTipText = "Fit Page Width";
            // 
            // Separator3
            // 
            this.Separator3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // ZoomInToolButton
            // 
            this.ZoomInToolButton.ImageIndex = 19;
            this.ZoomInToolButton.ToolTipText = "Zoom In Tool";
            // 
            // ZoomOutToolButton
            // 
            this.ZoomOutToolButton.ImageIndex = 20;
            this.ZoomOutToolButton.ToolTipText = "Zoom Out Tool";
            // 
            // Separator7
            // 
            this.Separator7.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // ZoomInButton
            // 
            this.ZoomInButton.ImageIndex = ((int)(configurationAppSettings.GetValue("ZoomInButton.ImageIndex", typeof(int))));
            this.ZoomInButton.ToolTipText = "Zoom In";
            // 
            // ZoomOutButton
            // 
            this.ZoomOutButton.ImageIndex = ((int)(configurationAppSettings.GetValue("ZoomOutButton.ImageIndex", typeof(int))));
            this.ZoomOutButton.ToolTipText = "Zoom Out";
            // 
            // Separator4
            // 
            this.Separator4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // FirstPageButton
            // 
            this.FirstPageButton.ImageIndex = ((int)(configurationAppSettings.GetValue("FirstPageButton.ImageIndex", typeof(int))));
            this.FirstPageButton.ToolTipText = "First Page";
            // 
            // PrevPageButton
            // 
            this.PrevPageButton.ImageIndex = ((int)(configurationAppSettings.GetValue("PrevPageButton.ImageIndex", typeof(int))));
            this.PrevPageButton.ToolTipText = "Previous Page";
            // 
            // NextPageButton
            // 
            this.NextPageButton.ImageIndex = ((int)(configurationAppSettings.GetValue("NextPageButton.ImageIndex", typeof(int))));
            this.NextPageButton.ToolTipText = "Next Page";
            // 
            // LastPageButton
            // 
            this.LastPageButton.ImageIndex = ((int)(configurationAppSettings.GetValue("LastPageButton.ImageIndex", typeof(int))));
            this.LastPageButton.ToolTipText = "Last Page";
            // 
            // Separator5
            // 
            this.Separator5.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // PageSingleButton
            // 
            this.PageSingleButton.ImageIndex = ((int)(configurationAppSettings.GetValue("PageSingleButton.ImageIndex", typeof(int))));
            this.PageSingleButton.ToolTipText = "Single Page";
            // 
            // PageSingleContButton
            // 
            this.PageSingleContButton.ImageIndex = ((int)(configurationAppSettings.GetValue("PageSingleContButton.ImageIndex", typeof(int))));
            this.PageSingleContButton.ToolTipText = "Single Continuous";
            // 
            // PageFacingContButton
            // 
            this.PageFacingContButton.ImageIndex = ((int)(configurationAppSettings.GetValue("PageFacingContButton.ImageIndex", typeof(int))));
            this.PageFacingContButton.ToolTipText = "Facing Continuous";
            // 
            // PageFacingButton
            // 
            this.PageFacingButton.ImageIndex = ((int)(configurationAppSettings.GetValue("PageFacingButton.ImageIndex", typeof(int))));
            this.PageFacingButton.ToolTipText = "Facing Pages";
            // 
            // Separator6
            // 
            this.Separator6.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // RotateClockwise
            // 
            this.RotateClockwise.ImageIndex = ((int)(configurationAppSettings.GetValue("RotateClockwise.ImageIndex", typeof(int))));
            this.RotateClockwise.ToolTipText = "Rotate Clockwise";
            // 
            // RotateCounterClockwise
            // 
            this.RotateCounterClockwise.ImageIndex = ((int)(configurationAppSettings.GetValue("RotateCounterClockwise.ImageIndex", typeof(int))));
            this.RotateCounterClockwise.ToolTipText = "Rotate Counterclockwise";
            // 
            // ToolbarImageList
            // 
            this.ToolbarImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ToolbarImageList.ImageStream")));
            this.ToolbarImageList.TransparentColor = System.Drawing.Color.Transparent;
            // 
            // statusBar
            // 
            this.statusBar.Location = new System.Drawing.Point(0, 550);
            this.statusBar.Name = "statusBar";
            this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
            this.statusBarPanel});
            this.statusBar.Size = new System.Drawing.Size(699, 19);
            this.statusBar.TabIndex = 3;
            this.statusBar.TabStop = true;
            // 
            // statusBarPanel
            // 
            this.statusBarPanel.Text = "statusBarPanel";
            // 
            // MainForm
            // 
            this.AllowDrop = true;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(699, 569);
            this.Controls.Add(this.statusBar);
            this.Controls.Add(this.ToolBar);
            this.Cursor = System.Windows.Forms.Cursors.Arrow;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.IsMdiContainer = true;
            this.KeyPreview = true;
            this.Menu = this.MainMenu;
            this.Name = "MainForm";
            this.Text = "PDFView";
            this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.OnKeyDown);
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			// Initialize PDFNet.
			try {
				PDFNet.Initialize();
			}
			catch(pdftron.Common.PDFNetException ex) {
				MessageBox.Show(ex.GetMessage(), "Licensing Error");
			}
			
			try 
			{
				// Optional: Set ICC color profiles to fine tune color conversion 
				// for PDF 'device' color spaces. You can use your own ICC profiles. 
				// Standard Adobe color profiles can be download from Adobes site: 
				// http://www.adobe.com/support/downloads/iccprofiles/iccprofiles_win.html
				//
				// Simply drop all *.icc files in PDFNet resource folder or you specify 
				// the full pathname.
				//---
				// PDFNet.SetColorManagement();
				// PDFNet.SetDefaultDeviceCMYKProfile("USWebCoatedSWOP.icc"); // will search in PDFNet resource folder.
				// PDFNet.SetDefaultDeviceRGBProfile("AdobeRGB1998.icc"); 

				// Optional: Set predefined font mappings to override default font 
				// substitution for documents with missing fonts. For example:
				//---
				// PDFNet.AddFontSubst("StoneSans-Semibold", "C:/WINDOWS/Fonts/comic.ttf");
				// PDFNet.AddFontSubst("StoneSans", "comic.ttf");  // search for 'comic.ttf' in PDFNet resource folder.
				// PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_Identity, "C:/WINDOWS/Fonts/arialuni.ttf");
				// PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_Japan1, "C:/Program Files/Adobe/Acrobat 7.0/Resource/CIDFont/KozMinProVI-Regular.otf");
				// PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_Japan2, "c:/myfonts/KozMinProVI-Regular.otf");
				//
				// If fonts are in PDFNet resource folder, it is not necessary to specify 
				// the full path name. For example,
				//---
				// PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_Korea1, "AdobeMyungjoStd-Medium.otf");
				// PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_CNS1, "AdobeSongStd-Light.otf");
				// PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_GB1, "AdobeMingStd-Light.otf");
			}
			catch (Exception)
			{
				MessageBox.Show("The specified color profile was not found.");
			}

			// Register the standard security handler (i.e. used to collect passwords). 
			pdftron.SDF.CreateDelegate del = new pdftron.SDF.CreateDelegate(PDFViewSecurityHandler.Create);
			pdftron.SDF.SecurityManagerSingleton.Instance().RegisterSecurityHandler("Standard", 
				new pdftron.SDF.SecurityDescriptor("Standard Security", del));
			
			Application.Run(new MainForm());

			PDFNet.Terminate();
		}

		private void OnFileOpen(object sender, System.EventArgs e)
		{
			OpenFileDialog dlg = new OpenFileDialog();
			dlg.CheckFileExists = true;
			dlg.CheckPathExists = true;
			dlg.Filter="PDF (*.pdf)|*.pdf|JPEG (*.jpg)|*.jpg|Bitmap (*.bmp)|*.bmp|PNG (*.png)|*.png|TIF (*.tif)|*.tif|All files (*.*)|*.*";
			dlg.DefaultExt = ".pdf";

			if(dlg.ShowDialog() == DialogResult.OK) 
			{				
				PDFViewForm view = new PDFViewForm(this);
				if (view.OpenPDF(dlg.FileName))
				{
					view.Show();
				}
			}

			// UpdateButtonStates();
		}

		public void UpdateButtonStates()
		{
			bool enabled = false; 
			if (this.MdiChildren != null && this.MdiChildren.Length>0) 
			{
				enabled = true;
			}
				
			this.FitPageButton.Enabled = enabled;
			this.FitWidthButton.Enabled = enabled;
			this.ZoomInButton.Enabled = enabled;
			this.ZoomOutButton.Enabled = enabled;
			this.ZoomInToolButton.Enabled = enabled;
			this.ZoomOutToolButton.Enabled = enabled;
			this.FirstPageButton.Enabled = enabled;
			this.PrevPageButton.Enabled = enabled;
			this.NextPageButton.Enabled = enabled;
			this.LastPageButton.Enabled = enabled;
			this.PageSingleButton.Enabled = enabled;
			this.PageSingleContButton.Enabled = enabled;
			this.PageFacingContButton.Enabled = enabled;
			this.PageFacingButton.Enabled = enabled;
			this.RotateClockwise.Enabled = enabled;
			this.RotateCounterClockwise.Enabled = enabled;
		}

		
		private void ToolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{

			if (e.Button == HandToolButton ||     // Custom PDFView tool modes
				e.Button == ZoomInToolButton || 
				e.Button == ZoomInToolButton || 
				e.Button == ZoomOutToolButton ||
				e.Button == PencilToolButton ||
				e.Button == LinkCreateToolButton ||
				e.Button == TextSelectButton ||
				e.Button == RectTextSelectButton)
			{
				if (e.Button == HandToolButton) 
				{
					HandToolButton.Pushed = true;
					PencilToolButton.Pushed =  false;
					ZoomInToolButton.Pushed = false; 
					ZoomOutToolButton.Pushed = false;
					LinkCreateToolButton.Pushed = false;
					TextSelectButton.Pushed = false;
					RectTextSelectButton.Pushed = false;
					SetToolMode(PDFViewCtrl.ToolMode.e_pan, MyPDFView.CustomToolMode.e_none);
				}
				else if (e.Button == ZoomInToolButton) 
				{
					HandToolButton.Pushed = false;
					PencilToolButton.Pushed =  false;
					ZoomInToolButton.Pushed = true; 
					ZoomOutToolButton.Pushed = false;
					LinkCreateToolButton.Pushed = false;
					TextSelectButton.Pushed = false;
					RectTextSelectButton.Pushed = false;
					SetToolMode(PDFViewCtrl.ToolMode.e_zoom_in, MyPDFView.CustomToolMode.e_none);
				}
				else if (e.Button == ZoomOutToolButton) 
				{
					HandToolButton.Pushed = false;
					PencilToolButton.Pushed =  false;
					ZoomInToolButton.Pushed = false; 
					ZoomOutToolButton.Pushed = true;
					LinkCreateToolButton.Pushed = false;
					TextSelectButton.Pushed = false;
					RectTextSelectButton.Pushed = false;
					SetToolMode(PDFViewCtrl.ToolMode.e_zoom_out, MyPDFView.CustomToolMode.e_none);
				}
				else if (e.Button == PencilToolButton) 
				{
					HandToolButton.Pushed = false;
					PencilToolButton.Pushed =  true;
					ZoomInToolButton.Pushed = false; 
					ZoomOutToolButton.Pushed = false;
					LinkCreateToolButton.Pushed = false;
					TextSelectButton.Pushed = false;
					RectTextSelectButton.Pushed = false;
					SetToolMode(PDFViewCtrl.ToolMode.e_custom, MyPDFView.CustomToolMode.e_custom_draw);
				}
				else if (e.Button == LinkCreateToolButton) 
				{
					HandToolButton.Pushed = false;
					PencilToolButton.Pushed =  false;
					ZoomInToolButton.Pushed = false; 
					ZoomOutToolButton.Pushed = false;
					LinkCreateToolButton.Pushed = true;
					TextSelectButton.Pushed = false;
					RectTextSelectButton.Pushed = false;
					SetToolMode(PDFViewCtrl.ToolMode.e_custom, MyPDFView.CustomToolMode.e_custom_link_create);
				}
				else if (e.Button == RectTextSelectButton) 
				{
					HandToolButton.Pushed = false;
					PencilToolButton.Pushed =  false;
					ZoomInToolButton.Pushed = false; 
					ZoomOutToolButton.Pushed = false;
					LinkCreateToolButton.Pushed = false;
					TextSelectButton.Pushed = false;
					RectTextSelectButton.Pushed = true;
					SetToolMode(PDFViewCtrl.ToolMode.e_text_rect_select, MyPDFView.CustomToolMode.e_none);
				}
				else if (e.Button == TextSelectButton) 
				{
					HandToolButton.Pushed = false;
					PencilToolButton.Pushed =  false;
					ZoomInToolButton.Pushed = false; 
					ZoomOutToolButton.Pushed = false;
					LinkCreateToolButton.Pushed = false;
					TextSelectButton.Pushed = true;
					RectTextSelectButton.Pushed = false;
					SetToolMode(PDFViewCtrl.ToolMode.e_text_struct_select, MyPDFView.CustomToolMode.e_none);
				}
			}

			if (e.Button == FileOpenButton) 
			{
				OnFileOpen(null, null);
			}
			else if (e.Button == SaveAsButton) 
			{				
				this.MenuFileSaveAs_Click(e.Button, e);
			}
			else if (e.Button == PrintButton) 
			{
				PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
				if (pdf_view != null) pdf_view.Print();
			}
			else if (e.Button == FitPageButton)	
			{
				PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
				if (pdf_view != null) pdf_view.FitPage();
			}
			else if (e.Button == FitWidthButton) 
			{
				PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
				if (pdf_view != null) pdf_view.FitWidth();
			}
			else if (e.Button == ZoomInButton)
			{
				OnZoomIn(sender, e);
			}
			else if (e.Button == ZoomOutButton)	
			{
				OnZoomOut(sender, e);
			}
			else if (e.Button == FirstPageButton) 
			{
				OnFirstPage(sender, e);
			}
			else if (e.Button == PrevPageButton) 
			{
				OnPrevPage(sender, e);
			}
			else if (e.Button == NextPageButton) 
			{
				OnNextPage(sender, e);
			}
			else if (e.Button == LastPageButton) 
			{
				OnLastPage(sender, e);
			}
			else if (e.Button == PageSingleButton) 
			{
				PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
				if (pdf_view != null) pdf_view.PageSingle();
			}
			else if (e.Button == PageSingleContButton) 
			{
				PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
				if (pdf_view != null) pdf_view.PageSingleContinuous();
			}
			else if (e.Button == PageFacingContButton) 
			{
				PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
				if (pdf_view != null) pdf_view.PageFacingContinuous();
			}
			else if (e.Button == PageFacingButton) 
			{
				PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
				if (pdf_view != null) pdf_view.PageFacing();
			}
			else if (e.Button == RotateClockwise) 
			{
				PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
				if (pdf_view != null) pdf_view.RotateClockwise();
			}
			else if (e.Button == RotateCounterClockwise)
			{
				PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
				if (pdf_view != null) pdf_view.RotateCounterClockwise();
			}
		}

		private void OnZoomIn(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.ZoomIn();		
		}

		private void OnZoomOut(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.ZoomOut();		
		}

		private void OnFirstPage(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.FirstPage();		
		}

		private void OnPrevPage(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.PrevPage();
		}

		private void OnNextPage(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.NextPage();
		}

		private void OnLastPage(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.LastPage();
		}

		private void OnAboutPDFView(object sender, System.EventArgs e)
		{
			MessageBox.Show("PDFView Sample Application Version 1.0", "About PDFView");
		}

		private void OnAppExit(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void OnSmoothImages(object sender, System.EventArgs e)
		{
			smooth_images = !smooth_images;
			this.MenuSmoothImages.Checked = smooth_images;
				
			Form[] children = this.MdiChildren;
			if (children != null) 
			{
				for (int i=0; i < children.Length; ++i)	
				{
					PDFViewForm pdf_view = (PDFViewForm) children[i];
					if (pdf_view != null) 
					{
						pdf_view.SetSmoothImages(smooth_images);
					}
				}
			}
		}

		private void OnAntiAlias(object sender, System.EventArgs e)
		{
			anti_alias = !anti_alias;
			this.MenuAntiAlias.Checked = anti_alias;
				
			Form[] children = this.MdiChildren;
			if (children != null) 
			{
				for (int i=0; i < children.Length; ++i)	
				{
					PDFViewForm pdf_view = (PDFViewForm) children[i];
					if (pdf_view != null) 
					{
						pdf_view.SetAntiAliasing(anti_alias);
					}
				}
			}
		}

		private void OnRasterizerToggle(object sender, System.EventArgs e)
		{
			builtin_rasterizer = !builtin_rasterizer;
			this.MenuBuiltInRasterizer.Checked = builtin_rasterizer;
				
			Form[] children = this.MdiChildren;
			if (children != null) 
			{
				for (int i=0; i < children.Length; ++i)	
				{
					PDFViewForm pdf_view = (PDFViewForm) children[i];
					if (pdf_view != null) 
					{
						pdf_view.SetRasterizer(builtin_rasterizer);
					}
				}
			}
		}

		private void OnFileClose(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) 
			{
				pdf_view.Close();
			}
			//UpdateButtonStates();
		}

		private void OnFileCloseAll(object sender, System.EventArgs e)
		{
			Form[] children = this.MdiChildren;
			if (children != null) 
			{
				for (int i=0; i < children.Length; ++i)	
				{
					PDFViewForm pdf_view = (PDFViewForm) children[i];
					if (pdf_view != null) 
					{
						pdf_view.Close();
					}
				} 
			}
			//UpdateButtonStates();		
		}

		public void UpdateStatusBar(int current_page, int num_pages)
		{
			if (current_page>0) 
			{
				string txt = String.Format("Page {0} of {1}.", current_page, num_pages);
				this.statusBar.Text = txt;
			}
		}

		private void OnWindowCascade(object sender, System.EventArgs e)
		{
			this.LayoutMdi(MdiLayout.Cascade);		
		}

		private void OnWindowTile(object sender, System.EventArgs e)
		{
			this.LayoutMdi(MdiLayout.TileHorizontal);
		}

		private void OnWindowTileVertical(object sender, System.EventArgs e)
		{
			this.LayoutMdi(MdiLayout.TileVertical);		
		}

		private void menuItemToolbar_Click(object sender, System.EventArgs e)
		{
			this.ToolBar.Visible=!ToolBar.Visible;
			this.menuItemToolbar.Checked=!this.menuItemToolbar.Checked;		
		}

		private void menuItemStatusbar_Click(object sender, System.EventArgs e)
		{
			this.statusBar.Visible=!statusBar.Visible;
			this.menuItemStatusbar.Checked=!this.menuItemStatusbar.Checked;		
		}

		private void MenuFileSaveAs_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.SaveAs();
		}

		private void MenuFileSave_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
		    if (pdf_view != null) pdf_view.Save(pdf_view.Text);
		}

		private void MenuFileExport_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.Export();
		}

		private void MenuPrint_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.Print();		
		}

		private void CopyText_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.CopySelectedText();
		}

		private void CopyTextAsHTML_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.CopySelectedText();
		}

		private void SelectAllText_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.SelectAll();
		}

		private void DeselectAllText_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.DeselectAll();
		}

		private void FindText_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.FindText();
		}

		private void DeletePages_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm)this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.DeletePages();
		}

		private void InsertBlankPages_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm)this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.InsertBlankPages();
		}

		private void InsertPages_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm)this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.InsertPages();
		}

		private void ReplacePages_Click(object sender, System.EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm)this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.ReplacePages();
		}

		private void OnKeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm) this.ActiveMdiChild;
			if (pdf_view != null) 
			{
				// Ctrl-F -> Find Text
				if (e.Modifiers == Keys.Control && e.KeyCode == Keys.F) 
					pdf_view.FindText();

				// Ctrl-C -> Copy Text
				if (e.Modifiers==Keys.Control && (e.KeyCode == Keys.C || e.KeyCode == Keys.Insert))
					pdf_view.CopySelectedText();

				// Ctrl-A -> Select All Text
				if (e.Modifiers==Keys.Control && e.KeyCode == Keys.A)
					pdf_view.SelectAll();
			}
		}

		private void SetToolMode(PDFViewCtrl.ToolMode tool_mode, MyPDFView.CustomToolMode custom_tool_mode) 
		{
			Form[] children = this.MdiChildren;
			if (children != null) 
			{
				for (int i=0; i < children.Length; ++i)	
				{
					PDFViewForm pdf_view = (PDFViewForm) children[i];
					if (pdf_view != null) 
					{
						pdf_view.SetToolMode(tool_mode, custom_tool_mode);
					}
				}
			}
		}

		private void menuPanTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_pan, MyPDFView.CustomToolMode.e_none);
		}

		private void menuStructTextTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_text_struct_select, MyPDFView.CustomToolMode.e_none);
		}

		private void menuRectTextTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_text_rect_select, MyPDFView.CustomToolMode.e_none);
		}

		private void menuRectZoomInTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_zoom_in, MyPDFView.CustomToolMode.e_none);
		}

		private void menuRectZoomOutTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_zoom_out, MyPDFView.CustomToolMode.e_none);
		}

		private void menuLineAnnotTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_line_create, MyPDFView.CustomToolMode.e_none);
		}

		private void menuRectAnnotTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_rect_create, MyPDFView.CustomToolMode.e_none);
		}

		private void menuEllipseAnnotTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_oval_create, MyPDFView.CustomToolMode.e_none);
		}

		private void menuFreeHandAnnotTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_ink_create, MyPDFView.CustomToolMode.e_none);
		}

		private void menuArrowAnnotTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_arrow_create, MyPDFView.CustomToolMode.e_none);
		}

		private void menuAnnotEditTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_annot_edit, MyPDFView.CustomToolMode.e_none);
		}

		private void menuCustomDrawTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_custom, MyPDFView.CustomToolMode.e_custom_draw);
		}

		private void menuCustomLinkTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_custom, MyPDFView.CustomToolMode.e_custom_link_create);
		}

		private void menuCustomTextSelectTool_Click(object sender, System.EventArgs e)
		{
			SetToolMode(PDFViewCtrl.ToolMode.e_text_struct_select, MyPDFView.CustomToolMode.e_custom_text_select_tool);
		}

		private void DocProperties_Click(object sender, EventArgs e)
		{
			PDFViewForm pdf_view = (PDFViewForm)this.ActiveMdiChild;
			if (pdf_view != null) pdf_view.DocProperties();
		}
	}
}
